/**
 * generated by Xtext 2.29.0
 */
package org.eclipse.papyrus.robotics.xtext.compdef.compDefText;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Component#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Component#getPorts <em>Ports</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Component#getActivity <em>Activity</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Component#getParameters <em>Parameters</em>}</li>
 * </ul>
 *
 * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getComponent()
 * @model
 * @generated
 */
public interface Component extends EObject
{
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getComponent_Name()
   * @model
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Component#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Ports</b></em>' containment reference list.
   * The list contents are of type {@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Port}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ports</em>' containment reference list.
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getComponent_Ports()
   * @model containment="true"
   * @generated
   */
  EList<Port> getPorts();

  /**
   * Returns the value of the '<em><b>Activity</b></em>' containment reference list.
   * The list contents are of type {@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Activity}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Activity</em>' containment reference list.
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getComponent_Activity()
   * @model containment="true"
   * @generated
   */
  EList<Activity> getActivity();

  /**
   * Returns the value of the '<em><b>Parameters</b></em>' containment reference list.
   * The list contents are of type {@link org.eclipse.papyrus.robotics.xtext.compdef.compDefText.Parameter}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parameters</em>' containment reference list.
   * @see org.eclipse.papyrus.robotics.xtext.compdef.compDefText.CompDefTextPackage#getComponent_Parameters()
   * @model containment="true"
   * @generated
   */
  EList<Parameter> getParameters();

} // Component
